Attribute VB_Name = "modCodici"
'=======================================================================================
' Descrizione.....: Variabili e codici per l' invio, l' acquisizione
'                   e la decodifica di toni audio.
' Nome dei Files..: modCodici.bas
' Data............: 19/03/2004 (Ver. 1.0)
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
' Parametri del codice tonale:
Public Codice$              ' Nome del codice da usare.
Public ToneWidth#           ' Durata di un tono [s].
Public SeqLength#           ' Durata di una sequenza [s].
Public MinGap#              ' Pausa minima fra le sequenza [s].
Public NTonesInSeq&         ' N di toni nella sequenza.
Public MaxTonesRX&          ' N massimo di toni nella sequenza in ricezione.
'
Public NTones&              ' N di toni nella tabella.
Public NTonesDec&           ' N di toni decodificabili.
Public ToneChar$()          ' Vettore dei caratteri associati ai toni.
Public ToneFreq#()          ' Vettore delle frequenze dei toni [Hz].
Public DeltaFreq#()         ' Vettore dei limiti min. e Max. delle frequenze [Hz]:
                            '  DeltaFreq(1, I) e' il valor minimo ammesso per la frequenza I.
                            '  DeltaFreq(2, I) e' il valor massimo ammesso per la frequenza I.
'
Public TnFMin#              ' Minima frequenza nella tabella dei toni [Hz].
Public TnFMax#              ' Massima frequenza nella tabella dei toni [Hz].
Public TolFreqTX#           ' Tolleranza sulla frequenza dei toni trasmessi [%].
Public TolFreqRX#           ' Tolleranza sulla frequenza dei toni ricevuti [%].
'
Public Type ToneTab_Type
    TnFMin As Double            ' Minima frequenza nella tabella dei toni [Hz].
    TnFMax As Double            ' Massima frequenza nella tabella dei toni [Hz].
    NTones As Long              ' N di toni nella tabella.
    NTonesDec As Long           ' N di toni decodificabili.
    Char() As String            ' Caratteri associati ai toni.
    Freq() As Double            ' Frequenze dei toni [Hz].
    DeltaFreq() As Double       ' Vettore dei limiti min. e Max. delle frequenze [Hz].
End Type
Public ToneTab As ToneTab_Type  ' Non usato, in questa versione.
'
' Corrispondenze Sequenze -> Testi:
Private Type SeqTxt_Type        '
    Sequenza As String          '
    Testo As String             '
End Type                        '
Private SeqTxt() As SeqTxt_Type ' Vettore delle corrispondenze Sequenza -> Testo.
Private NSeqTxt&                ' N di corrispondenze nel vettore SeqTxt().
Public FileSeqTxt$              ' File corrente delle corrispondenze Sequenze -> Testi.

Public Function LeggiFileSeqTxt(ByVal FileN$) As Boolean
'
'
    Dim FF%
'
    On Error GoTo LeggiFileSeqTxt_ERR
'
    NSeqTxt = 0
'
    FF = FreeFile
    Open FileN$ For Input As #FF
'
    Do While Not EOF(FF)
        NSeqTxt = NSeqTxt + 1
        ReDim Preserve SeqTxt(1 To NSeqTxt)
        Input #FF, SeqTxt(NSeqTxt).Sequenza, SeqTxt(NSeqTxt).Testo
    Loop
'
'
LeggiFileSeqTxt_ERR:
    Close #FF
    LeggiFileSeqTxt = (Err.Number = 0)
'
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Errore di lettura del file Sequenze -> Testi:" & vbNewLine
        M$ = M$ & "  " & FileN$ & vbNewLine & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modCodici: LeggiFileSeqTxt"
    End If
'
'
'
End Function
Public Function SeqToTxt(ByVal Sequenza$) As String
'
'   Ritorna il testo associato alla
'   sequenza Sequenza$:
'
    Dim I&
'
    For I = 1 To NSeqTxt
        If Sequenza$ = SeqTxt(I).Sequenza Then
            SeqToTxt = SeqTxt(I).Testo
            Exit Function
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    SeqToTxt = ""
'
'
'
End Function
Public Sub CCIRVVF()
'
'   Imposta i parametri del codice CCIR1 dei Vigili del Fuoco.
'   Rimosso, per motivi di riservatezza.
'
'
'
End Sub
Public Sub CCIR1()
'
'   Imposta i parametri del codice CCIR1:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.1
    MinGap = 0.29
    SeqLength = 0.5
    TolFreqTX = 100 * 8# / 2400#  ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1#                ' Tolleranza sulla frequenza del tono ricevuto [%].
    NTonesInSeq = CLng(SeqLength / ToneWidth)
'
    NTones = 16     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 1981#
    ToneChar$(1) = "1":  ToneFreq(1) = 1124#
    ToneChar$(2) = "2":  ToneFreq(2) = 1197#
    ToneChar$(3) = "3":  ToneFreq(3) = 1275#
    ToneChar$(4) = "4":  ToneFreq(4) = 1358#
    ToneChar$(5) = "5":  ToneFreq(5) = 1446#
    ToneChar$(6) = "6":  ToneFreq(6) = 1540#
    ToneChar$(7) = "7":  ToneFreq(7) = 1640#
    ToneChar$(8) = "8":  ToneFreq(8) = 1747#
    ToneChar$(9) = "9":  ToneFreq(9) = 1860#
    ToneChar$(10) = "A": ToneFreq(10) = 2400#
    ToneChar$(11) = "B": ToneFreq(11) = 930#
    ToneChar$(12) = "C": ToneFreq(12) = 2247#
    ToneChar$(13) = "D": ToneFreq(13) = 991#
    ToneChar$(14) = "E": ToneFreq(14) = 2110#
    ToneChar$(15) = "F": ToneFreq(15) = 1055#
    ' Ordine per frequenza crescente: BDF1234567890ECA.
    ' FMin = 930 [Hz]; FMax = 2400 [Hz]
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 930#
    TnFMax = 2400#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Sub CCIR2()
'
'   Imposta i parametri del codice CCIR2:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.07
    MinGap = 0.29
    SeqLength = 0.5
    TolFreqTX = 100 * 3# / 930  ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1#              ' Tolleranza sulla frequenza del tono ricevuto [%].
    NTonesInSeq = CLng(SeqLength / ToneWidth)
'
    NTones = 16     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 1981#
    ToneChar$(1) = "1":  ToneFreq(1) = 1124#
    ToneChar$(2) = "2":  ToneFreq(2) = 1197#
    ToneChar$(3) = "3":  ToneFreq(3) = 1275#
    ToneChar$(4) = "4":  ToneFreq(4) = 1358#
    ToneChar$(5) = "5":  ToneFreq(5) = 1446#
    ToneChar$(6) = "6":  ToneFreq(6) = 1540#
    ToneChar$(7) = "7":  ToneFreq(7) = 1640#
    ToneChar$(8) = "8":  ToneFreq(8) = 1747#
    ToneChar$(9) = "9":  ToneFreq(9) = 1860#
    ToneChar$(10) = "A": ToneFreq(10) = 2400#
    ToneChar$(11) = "B": ToneFreq(11) = 930#
    ToneChar$(12) = "C": ToneFreq(12) = 2247#
    ToneChar$(13) = "D": ToneFreq(13) = 991#
    ToneChar$(14) = "E": ToneFreq(14) = 2110#
    ToneChar$(15) = "F": ToneFreq(15) = 1055#
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 930#
    TnFMax = 2400#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Sub CRI()
'
'   Imposta i parametri del codice CRI (ZVEI II):
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.07
    MinGap = 0.14
    SeqLength = 0.91
'
    NTonesInSeq = CLng(SeqLength / ToneWidth)
    TolFreqTX = 1.5 ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1#  ' Tolleranza sulla frequenza del tono ricevuto [%].
'
    NTones = 14     ' N totale di toni nella tabella.
    NTonesDec = 13  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 2400#
    ToneChar$(1) = "1":  ToneFreq(1) = 1060#
    ToneChar$(2) = "2":  ToneFreq(2) = 1160#
    ToneChar$(3) = "3":  ToneFreq(3) = 1270#
    ToneChar$(4) = "4":  ToneFreq(4) = 1400#
    ToneChar$(5) = "5":  ToneFreq(5) = 1530#
    ToneChar$(6) = "6":  ToneFreq(6) = 1670#
    ToneChar$(7) = "7":  ToneFreq(7) = 1830#
    ToneChar$(8) = "8":  ToneFreq(8) = 2000#
    ToneChar$(9) = "9":  ToneFreq(9) = 2200#
    ToneChar$(10) = "G": ToneFreq(10) = 886#
    ToneChar$(11) = "B": ToneFreq(11) = 810#
    ToneChar$(12) = "R": ToneFreq(12) = 970#
    ToneChar$(13) = " ": ToneFreq(13) = 0#
'
    SC$ = "R"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 810#
    TnFMax = 2400#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Sub EEA()
'
'   Imposta i parametri del codice EEA:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.04
    MinGap = 0.1
    SeqLength = 0.2
'
    NTonesInSeq = CLng(SeqLength / ToneWidth)
    TolFreqTX = 1#  ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1#  ' Tolleranza sulla frequenza del tono ricevuto [%].
'
    NTones = 17     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 1981#
    ToneChar$(1) = "1":  ToneFreq(1) = 1124#
    ToneChar$(2) = "2":  ToneFreq(2) = 1197#
    ToneChar$(3) = "3":  ToneFreq(3) = 1275#
    ToneChar$(4) = "4":  ToneFreq(4) = 1358#
    ToneChar$(5) = "5":  ToneFreq(5) = 1446#
    ToneChar$(6) = "6":  ToneFreq(6) = 1540#
    ToneChar$(7) = "7":  ToneFreq(7) = 1640#
    ToneChar$(8) = "8":  ToneFreq(8) = 1747#
    ToneChar$(9) = "9":  ToneFreq(9) = 1860#
    ToneChar$(10) = "A": ToneFreq(10) = 1055#
    ToneChar$(11) = "B": ToneFreq(11) = 930#
    ToneChar$(12) = "C": ToneFreq(12) = 2400#
    ToneChar$(13) = "D": ToneFreq(13) = 991#
    ToneChar$(14) = "E": ToneFreq(14) = 2110#
    ToneChar$(15) = "F": ToneFreq(15) = 2247#
    ToneChar$(16) = "_": ToneFreq(16) = 0#
    ' Ordine per frequenza crescente: BDA1234567890EFC.
    ' FMin = 930 [Hz]; FMax = 2400 [Hz]
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 930#
    TnFMax = 2400#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Sub EIA()
'
'   Imposta i parametri del codice EIA:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.033
    MinGap = 0.033
    SeqLength = 0.165
'
    NTonesInSeq = CLng(SeqLength / ToneWidth)
    TolFreqTX = 1#  ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1#                ' Tolleranza sulla frequenza del tono ricevuto [%].
'
    NTones = 17     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 600#
    ToneChar$(1) = "1":  ToneFreq(1) = 741#
    ToneChar$(2) = "2":  ToneFreq(2) = 882#
    ToneChar$(3) = "3":  ToneFreq(3) = 1023#
    ToneChar$(4) = "4":  ToneFreq(4) = 1164#
    ToneChar$(5) = "5":  ToneFreq(5) = 1305#
    ToneChar$(6) = "6":  ToneFreq(6) = 1446#
    ToneChar$(7) = "7":  ToneFreq(7) = 1587#
    ToneChar$(8) = "8":  ToneFreq(8) = 1728#
    ToneChar$(9) = "9":  ToneFreq(9) = 1869#
    ToneChar$(10) = "A": ToneFreq(10) = 2151#
    ToneChar$(11) = "B": ToneFreq(11) = 2433#
    ToneChar$(12) = "C": ToneFreq(12) = 2010#
    ToneChar$(13) = "D": ToneFreq(13) = 2292#
    ToneChar$(14) = "E": ToneFreq(14) = 459#
    ToneChar$(15) = "F": ToneFreq(15) = 1091#
    ToneChar$(16) = "_": ToneFreq(16) = 0#
    ' Ordine per frequenza crescente: E0123F456789CADB.
    ' FMin = 930 [Hz]; FMax = 2400 [Hz]
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 459#
    TnFMax = 2433#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Function CodeToInd(ByVal Char$) As Long
'
'   Ritorna l' indice del carattere Char$:
'
    Dim I&
'
    For I = 0 To NTones - 1
        If ToneChar$(I) = Char$ Then
            CodeToInd = I
            Exit Function
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    CodeToInd = 0
'
'
'
End Function
Public Function CodeToFreq(ByVal Char$) As Double
'
'   Ritorna la frequenza associata al carattere Char$:
'
    Dim I& ', Freq#, FMin#, FMax#, FTol#
'
    For I = 0 To NTones - 1
        If ToneChar$(I) = Char$ Then
            ' Per prove:
'            FTol = 1 * TolFreqTX
'            FMin = ToneFreq(I) * (1 - FTol / 100)
'            FMax = ToneFreq(I) * (1 + FTol / 100)
'            Freq = RandU(FMin, FMax)
'            'Freq = IIf(0 < RandU(-1, 1), FMin, FMax)
'            CodeToFreq = Freq
'
            CodeToFreq = ToneFreq(I)
            Exit Function
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    CodeToFreq = -1#
'
'
'
End Function
Public Function FreqToCode(ByVal Freq As Double) As String
'
'   Ritorna il carattere associato alla frequenza Freq:
'
    Dim I&
'
    For I = 0 To NTones - 1
        If (DeltaFreq(1, I) <= Freq) And (Freq <= DeltaFreq(2, I)) Then
            FreqToCode = ToneChar$(I)
            Exit Function
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    FreqToCode = ""
'
'
'
End Function
Public Sub Euro_7()
'
'   Imposta i parametri del codice Euro Signal a 7 toni:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.1
    MinGap = 0.105  ' Valore arbitrario, non definito dallo standard.
    SeqLength = 0.7
'
    NTonesInSeq = CLng(SeqLength / ToneWidth)
    TolFreqTX = 1#  ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1#  ' Tolleranza sulla frequenza del tono ricevuto [%].
'
    NTones = 16     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 979.8
    ToneChar$(1) = "1":  ToneFreq(1) = 903.1
    ToneChar$(2) = "2":  ToneFreq(2) = 832.5
    ToneChar$(3) = "3":  ToneFreq(3) = 767.4
    ToneChar$(4) = "4":  ToneFreq(4) = 707.4
    ToneChar$(5) = "5":  ToneFreq(5) = 652#
    ToneChar$(6) = "6":  ToneFreq(6) = 601#
    ToneChar$(7) = "7":  ToneFreq(7) = 554#
    ToneChar$(8) = "8":  ToneFreq(8) = 510.7
    ToneChar$(9) = "9":  ToneFreq(9) = 470.8
    ToneChar$(10) = "A": ToneFreq(10) = 1200# ' Valore fittizio, non definito dallo standard.
    ToneChar$(11) = "B": ToneFreq(11) = 1300# '    "      "       "     "       "      "
    ToneChar$(12) = "C": ToneFreq(12) = 1400# '    "      "       "     "       "      "
    ToneChar$(13) = "D": ToneFreq(13) = 1500# '    "      "       "     "       "      "
    ToneChar$(14) = "E": ToneFreq(14) = 1062.9
    ToneChar$(15) = "F": ToneFreq(15) = 1600# '    "      "       "     "       "      "
    ' Ordine per frequenza crescente: 9876543210EABCDF.
    ' FMin = 470.8 [Hz]; FMax = 1600 [Hz]
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 470.8
    TnFMax = 1600#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Sub ZVEI2()
'
'   Imposta i parametri del codice ZVEI2:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.07
    MinGap = 0.14
    SeqLength = 0.35
'
    NTonesInSeq = CLng(SeqLength / ToneWidth)
    TolFreqTX = 1.5 ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1.5 ' Tolleranza sulla frequenza del tono ricevuto [%].
'
    NTones = 16     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 2400#
    ToneChar$(1) = "1":  ToneFreq(1) = 1060#
    ToneChar$(2) = "2":  ToneFreq(2) = 1160#
    ToneChar$(3) = "3":  ToneFreq(3) = 1270#
    ToneChar$(4) = "4":  ToneFreq(4) = 1400#
    ToneChar$(5) = "5":  ToneFreq(5) = 1530#
    ToneChar$(6) = "6":  ToneFreq(6) = 1670#
    ToneChar$(7) = "7":  ToneFreq(7) = 1830#
    ToneChar$(8) = "8":  ToneFreq(8) = 2000#
    ToneChar$(9) = "9":  ToneFreq(9) = 2200#
    ToneChar$(10) = "A": ToneFreq(10) = 885#
    ToneChar$(11) = "B": ToneFreq(11) = 810#
    ToneChar$(12) = "C": ToneFreq(12) = 740#
    ToneChar$(13) = "D": ToneFreq(13) = 680#
    ToneChar$(14) = "E": ToneFreq(14) = 970#
    ToneChar$(15) = "F": ToneFreq(15) = 2600#
    ' Ordine per frequenza crescente: DCBAE1234567890F.
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 680#
    TnFMax = 2600#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
Public Sub ZVEI1()
'
'   Imposta i parametri del codice ZVEI1:
'
    Dim I&
'
    MaxTonesRX = 16
    ToneWidth = 0.07
    MinGap = 0.14
    SeqLength = 0.35
'
    NTonesInSeq = CLng(SeqLength / ToneWidth)
    TolFreqTX = 1.5 ' Tolleranza sulla frequenza del tono trasmesso [%].
    TolFreqRX = 1.5 ' Tolleranza sulla frequenza del tono ricevuto [%].
'
    NTones = 16     ' N totale di toni nella tabella.
    NTonesDec = 16  ' N di toni decodificabili.
'
    ReDim ToneChar$(0 To NTones - 1), ToneFreq#(0 To NTones - 1)
    ToneChar$(0) = "0":  ToneFreq(0) = 2400#
    ToneChar$(1) = "1":  ToneFreq(1) = 1060#
    ToneChar$(2) = "2":  ToneFreq(2) = 1160#
    ToneChar$(3) = "3":  ToneFreq(3) = 1270#
    ToneChar$(4) = "4":  ToneFreq(4) = 1400#
    ToneChar$(5) = "5":  ToneFreq(5) = 1530#
    ToneChar$(6) = "6":  ToneFreq(6) = 1670#
    ToneChar$(7) = "7":  ToneFreq(7) = 1830#
    ToneChar$(8) = "8":  ToneFreq(8) = 2000#
    ToneChar$(9) = "9":  ToneFreq(9) = 2200#
    ToneChar$(10) = "A": ToneFreq(10) = 2800#
    ToneChar$(11) = "B": ToneFreq(11) = 810#
    ToneChar$(12) = "C": ToneFreq(12) = 970#
    ToneChar$(13) = "D": ToneFreq(13) = 885#
    ToneChar$(14) = "E": ToneFreq(14) = 2600#
    ToneChar$(15) = "F": ToneFreq(15) = 680#
'
    SC$ = "E"   ' Carattere da sostituire con doppi caratteri.
'
    TnFMin = 680#
    TnFMax = 2800#
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NTones - 1)
    For I = 0 To NTones - 1
        DeltaFreq(1, I) = (100# - TolFreqTX) * ToneFreq(I) / 100#
        DeltaFreq(2, I) = (100# + TolFreqTX) * ToneFreq(I) / 100#
    Next I
'
'
'
End Sub
