Attribute VB_Name = "modDecoToni"
'=======================================================================================
' Descrizione.....: Variabili, costanti e routines per l' invio,
'                   l' acquisizione e la decodifica di toni audio.
' Nome dei Files..: frmDecoToni.frm, frmDecoToni.frx,
'                   frmConsole.frm, frmConsole.frx,
'                   frmOpzioni.frm, frmOpzioni.frx,
'                   frmGrafici.frm, frmGrafici.frx,
'                   frmInfoCr.frm, frmInfoCr.frx,
'                   frmIstruzioni.frm, frmIstruzioni.frx,
'                   modDecoToni.bas, modDSP.bas, modComplex.bas,
'                   modCodici.bas, modUtilita.bas, modFlexPB.bas,
'                   modMixerControl.bas, modCommonDialog.
' Data............: 08/03/2004 (Ver. 1.0, Selettive).
' Aggiornamento...: 19/03/2004 (Ver. 2.1).
' Aggiornamento...: 11/01/2005 (Ver. 2.2, aggiunta la decodifica sequenze -> testi)
' Aggiornamento...: 17/04/2009 (Ver. 3.0).
' Aggiornamento...: 10/10/2009 (Ver. 4.0, nuova versione della gestione delle
'                               schede audio, etc...).
' Revisione.......: 26/03/2010 (Ver. 4.0.r, eliminati alcuni "bugs" della versione
'                               precedente).
' Versione........: 4.0.r a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
'   Nota 1: questo progetto e' stato sviluppato usando il "." come
'           separatore decimale; nonostante abbia cercato di prevenire
'           possibili problemi dovuti all' uso della "," non posso
'           escludere che sia rimasta qualche incongruenza.
'           In caso di malfunzionamenti dovuti a questo problema,
'           provate a cambiare sul vostro PC le impostazioni interna-
'           zionali e datemi notizia dei "bugs" trovati.
'
'   Nota 2: ho introdotto l' unita' di misura [DigVal] per indicare valori
'           digitali a 16 Bits, i.e. quelli direttamente ritornati dal
'           convertitore A/D della scheda audio.
'           L' unita' [campioni] e' per le grandezze misurabili in [s * Fs].
'
Option Explicit
'
Public MixerSpI&        ' Indice, in MixerSp(), del mixer corrente di tipo SPEAKERS.
                        '  1 <= MixerSpI <= NMixSp.
Public MixerWiI&        ' Indice, in MixerWi(), del mixer corrente di tipo WAVEIN;
                        '  1 <= MixerWiI <= NMixWi.
'
Public FsRX#            ' Frequenza di campionamento in ricezione    [Hz].
Public FsTX#            '    "      "       "        "  trasmissione  "
'
Public NcRX&            ' N di campioni nei vettori dei dati per acquisizione [campioni].
Public NcToneRX&        ' N di campioni in un tono della sequenza ricevuta [campioni].
Private NcToneTX&       ' N di campioni in un tono della sequenza da trasmettere [campioni].
Private NcGapRX&        ' N di campioni nella pausa della sequenza ricevuta [campioni].
Private NcGapTX&        ' N di campioni nella pausa della sequenza da trasmettere [campioni].
Public NcSeqRX&         ' N di campioni nella sequenza ricevuta di MaxTonesRX& toni [campioni].
Public NcVin&           ' Lunghezza del vettore di accumulo [campioni].
Private VIn!()          ' Vettore di accumulo [DigVal].
Private NcVin2&         ' Lunghezza del vettore di accumulo per tutti i dati in ingresso [campioni].
Private VIn2!()         ' Vettore di accumulo per tutti i dati in ingresso [DigVal].
Public NcOff&           ' Offset per centratura nel tono, i.e. (NcToneRX - NcFT) / 2 [campioni].
Public TrigLivMin!      ' Livello di trigger sotto il quale si e' in pausa [DigVal].
Public TrigLivMax!      ' Livello di trigger sopra il quale c' e' segnale [DigVal].
Public SogliaSigRMS#    ' Livello minimo accettabile del valore efficace del segnale [DigVal].
Private NcZeri&         ' N di campioni consecutivi con valore < TrigLivMin
                        ' necessari a decidere la presenza di una pausa [campioni].
Private NcP2&           ' Doppio del numero di campioni in un periodo della
                        ' frequenza piu' bassa dei toni [campioni].
'
Public TmsSeqTX&        ' Durata della sequenza da trasmettere [ms].
'
Private IcI&, IcIf&     ' Puntatori al campione corrente e per la (non) separazione delle sequenze [campioni].
'
Public NcSeqSep&        ' N di campioni per la separazione delle sequenze ricevute [campioni].
Public MinCar&          ' N minimo di caratteri per una sequenza accettabile.
Private StringaRX$      ' Stringa di accumulo dei caratteri decodificati.
'
Public bSuonaOn As Boolean          ' Flag di SuonaSequenza in corso.
Public bAcqOn As Boolean            ' Flag di Acquisizione in corso.
'
Private bRicercaPausa As Boolean    ' Flags di stato ricerca pausa
Private bRicercaTrigger As Boolean  ' e di stato ricerca segnale.
Public SC$                          ' Carattere da sostituire con doppi caratteri.
Public bSostSCRX As Boolean         ' Sostituzione, in ricezione, di SC$ con doppi caratteri.
Public bSostSCTX As Boolean         ' Sostituzione, in trasmissione, dei doppi caratteri con SC$.
Public bAutoScroll As Boolean       ' Flag di posizionamento automatico nella tabella delle strighe rivevute.
Public bVVF As Boolean              ' Flag di ricerca dei toni di lunghezza doppia
                                    ' (solo per il codice VVF, eliminato per riservatezza).
'
' Per decodifica con DFT:
Public NcFT&            ' N di campioni per la "Fourier Transform" (FFT o DFT) [campioni].
Private D#()            ' Vettore dei dati reali da trasformare con DFT.
Private Rea#()          ' Vettore della parte reale della trasformata.
Private Imm#()          ' Vettore della parte immaginaria della trasformata.
Private SSp#()          ' Vettore dello spettro di ampiezza.
Private SMax#           ' Valor massimo presente nello spettro di ampiezza.
Private ISMax&          ' Indice del valor massimo presente nello spettro di ampiezza.
Private WinP#()         ' Vettore profilo di Windows.
Public ALFA#            ' Rapporto minimo SMax/SMed per il riconoscimento di un carattere.
'
' Per decodifica con spettri mobili:
Private SpmMF#()            ' Vettore degli spettri mobili multifrequenza.
Private MMbSg#              ' Media (o valore efficace) mobile del segnale [DigVal].
Private vSPM#(), vMMb#()    ' Vettori per grafici di uno spettro mobile e della media mobile.
Private IcSpm&()            ' Vettore dei numeri di campioni con spettro > Beta * valor medio [campioni].
Private IcSpmMax&           ' SPM: N di soglia per il numero di campioni con spettro > Beta * valor medio [campioni].
Private Beta#               ' Rapporto minimo SPM/SMed.
Private NcSpmCont&()        ' Vettore dei numeri di campioni con spettro > Beta * valor medio [campioni].
Private NcSpmSuff&          ' SSC: N di soglia per il numero di campioni con spettro > Beta * valor medio [campioni].
Private NcSpmComp&          ' N di campioni NcToneRX - NcSpmSuff [campioni].
Private NcToneRX_2&         ' Meta' del N di campioni in un tono [campioni].
'
Private IcP&, IcV&, IcV1&, IcSc&    ' Indici per la ricerca della pausa, per il
                                    ' riempimento del vettore VIn(), per marcare
                                    ' la fine di un blocco di dati e per scartare
                                    ' segnali troppo corti [campioni].
Private Ic&, IcIs&, IcO&            ' Variabili per la (non) separazione delle sequenze [campioni].
'
Public DecM&                ' Metodo di decodifica. Puo' essere solo:
Public Const DecDFT& = 1    '  decodifica con DFT;
Public Const DecSPM& = 2    '  decodifica con spettro mobile;
Public Const DecSSC& = 3    '  decodifica con spettro mobile su segnale completo.
Public bSSC_NS As Boolean   ' Flag di soglia disabilitata su decodifica SSC.
'
' Per grafici:
Public CarSpettro$, ICarSpettro&    ' Carattere e indice del carattere per il quale
                                    ' e' richiesto il grafico dello spettro.
Public ViMax!                       ' Scala verticale del grafico del segnale [DigVal].
'
Private Const MaxCar& = 200         ' Numero massimo di caratteri memorizzabili.
Private Char$()                     ' Vettore dei caratteri trovati
Private PosChar&()                  ' e loro relative posizioni.
Private SpmG#(), MMbG#()            ' Vettori di uno spettro mobile e della media mobile.
'
Public bDisegnaGrafici As Boolean   ' Flag di disegno dei grafici.
'
Public bFiltroON As Boolean         ' Flag di filtro inserito.
Private FiltFMin#, FiltFMax#        ' Frequenze di taglio min. e Max del filtro
                                    ' passa-banda [f/fs].
'
                                    ' Filtro FIR:
Private Const NFilt& = 32           '  N di coefficienti del filtro.
'
                                    ' Filtro IIR:
Private NK&, NCel&                  '  Ordine e numero di sezioni,
Private w!()                        '  registri delle sezioni [DigVal],
Private Ac!(), Bc!()                '  e vettori dei coefficienti del filtro.
'
Public Const NCanali% = 1           ' Deve essere Mono.
Public Const BitsPerSample% = 16    ' Risoluzione del campionamento.  In questa
                                    ' versione e' sempre di 16 bits.
'
Public Const Amp16Max# = 32767#     ' Massima ampiezza del suono a 16 bits.
Public Amp16#                       ' Ampiezza del suono emesso.
'
' Per Acquisizione:
Private phwi&           ' Handle del "waveform-audio input device".
Private NBuff&          ' N di buffers per l' acquisizione.
Private InData%()       ' Matrice dei dati acquisiti (Integer, per acquisizione a 16 bits) [DigVal].
Private InDataC%()      ' Vettore copia dei buffers di acquisizione [DigVal].
Private WaveInHdr() As WAVEHDR
Private LenInHeaders&   ' = Len(WaveInHdr(1))
'
' Per SuonaSequenza:
Private phwo&           ' Handle del "waveform-audio output device".
Private OutData%()      ' Vettore dei dati da emettere (Integer, per suono a 16 bits) [DigVal].
Private WaveOutHdr As WAVEHDR
Private LenOutHeader&   ' = Len(WaveOutHdr)
'
Public FileINI$         ' File dei parametri dello strumento.
'
'--  Costanti, tipi e dichiarazioni per API: -------------------------------------------
'
Public Declare Function GetTickCount Lib "kernel32" () As Long
'
Private Const WHDR_DONE& = &H1&     ' /* done bit */
Private Const WAVE_FORMAT_PCM& = 1
'
Private Const MMSYSERR_NOERROR& = 0 ' no error
'
Private Type WAVEHDR
    lpData As Long
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    dwLoops As Long
    lpNext As Long  ' Reserved.
    Reserved As Long
End Type
'
Private Type WAVEFORMATEX
    wFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    wBitsPerSample As Integer
    cbSize As Integer
End Type
'
Private Declare Function waveInOpen Lib "winmm.dll" _
    (WaveDeviceInputHandle As Long, ByVal WhichDevice As Long, _
    ByVal WaveFormatExPointer As Long, ByVal CallBack As Long, _
    ByVal CallBackInstance As Long, ByVal Flags As Long) As Long
Public Declare Function waveInClose Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
'
Private Declare Function waveInStart Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
Public Declare Function waveInReset Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
Private Declare Function waveInStop Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
'
Private Declare Function waveInAddBuffer Lib "winmm.dll" _
    (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, _
    ByVal WaveHdrStructSize As Long) As Long
Private Declare Function waveInPrepareHeader Lib "winmm.dll" _
    (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, _
    ByVal WaveHdrStructSize As Long) As Long
Public Declare Function waveInUnprepareHeader Lib "winmm.dll" _
    (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, _
    ByVal WaveHdrStructSize As Long) As Long
'
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
'
'---------------------------------------------------------------------------------------
'
Private Declare Function waveOutOpen Lib "winmm.dll" _
    (lphWaveOut As Long, ByVal uDeviceID As Long, _
    ByVal lpFormat As Long, ByVal dwCallback As Long, _
    ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Private Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Private Declare Function waveOutPrepareHeader Lib "winmm.dll" _
    (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Private Declare Function waveOutUnprepareHeader Lib "winmm.dll" _
    (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Private Declare Function waveOutWrite Lib "winmm.dll" _
    (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Private Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveOut As Long) As Long

Public Sub ImpostaParametri()
'
'
    ' Imposto i parametri dei codici:
    Select Case Codice$
    Case "CCIR1"
        Call CCIR1
'
    Case "CCIR2"
        Call CCIR2
'
    Case "CRI"
        Call CRI
'
    Case "EEA"
        Call EEA
'
    Case "EIA"
        Call EIA
'
    Case "Euro_7"
        Call Euro_7
'
    Case "ZVEI1"
        Call ZVEI1
'
    Case "ZVEI2"
        Call ZVEI2
'
    ' ............
        ' ............
    End Select
'
    bVVF = (Codice$ = "CCIRVVF")
    frmConsole.chkDoppioLungToni.Visible = bVVF ' Carica anche i Forms.
'
    ' Leggo le corrispondenze Sequenza -> Testo:
    If FileExists(FileSeqTxt$) Then
        LeggiFileSeqTxt FileSeqTxt$
    Else
        FileSeqTxt$ = ""
    End If
'
    ' Parametri della ricezione/decodifica:
    NcP2 = 2 * CLng(FsRX / TnFMin)     ' Doppio del numero di campioni in un periodo
                                       ' della frequenza piu' bassa dei toni.
'
    NcToneRX = CLng(ToneWidth * FsRX)  ' N di campioni in un tono della sequenza ricevuta.
    NcSeqRX = CLng(CDbl(MaxTonesRX) * ToneWidth * FsRX) ' N di campioni nella sequenza ricevuta di MaxTonesRX& toni
    NcZeri = CLng(0.3 * MinGap * FsRX) ' N di campioni consecutivi con valore < TrigLivMin
                                       ' necessari a decidere la presenza di una pausa.
'
    NcRX = CLng(1.1 * (CDbl(MaxTonesRX) * ToneWidth + MinGap / 2#) * FsRX) ' N di campioni nei vettori dei dati per acquisizione.
    NcVin = CLng(1.05 * (CDbl(MaxTonesRX)) * ToneWidth * FsRX)             ' Lunghezza del vettore di accumulo.
    ReDim VIn(1 To NcVin)
'
    ' Per decodifica del segnale completo:
    NcVin2 = NcRX
    ReDim VIn2(1 To NcVin2)
'
    TrigLivMin = 2500!  ' Valori arbitrari:
    TrigLivMax = 3000!  ' possono essere resi adattativi.
'
    ' Parametri per la DFT:
    NcFT = 2 ^ Int(Log(ToneWidth * FsRX) / Log2)
'
    ReDim D(0 To NcFT - 1), Rea(0 To NcFT - 1), Imm(0 To NcFT - 1)
    ReDim SSp(0 To NTonesDec - 1)
    NcOff = (NcToneRX - NcFT) / 2
'
    ' Inizializzo la DFT_1:
    DFT_1_Init NcFT, NTonesDec, ToneFreq(), FsRX
'
    ' Calcolo il profilo della Windows:
    ReDim WinP(0 To NcFT - 1)
    'WinP() = WinProf("Lanczos", NcFT, 0.6)
    WinP() = WinProf("Hanning", NcFT)
'
    ' Inizializzo lo spettro mobile:
    SPM_MF_Init NcToneRX / 4, NTonesDec, ToneFreq(), FsRX   ' Multi frequenza.
    ReDim SpmMF(0 To NTonesDec - 1)                         '   "      "
    ReDim IcSpm(0 To NTonesDec - 1)                         '   "      "
    ReDim NcSpmCont(0 To NTonesDec - 1)                     '   "      "
'
    ' Parametri per spettro mobile:
    NcToneRX_2 = NcToneRX / 2
    IcSpmMax = CLng(0.7 * NcToneRX) ' SPM: N di soglia per il numero di campioni
                                    ' con spettro > Beta * valor medio.
    Beta = 1.1                      ' Rapporto minimo SPM/SMed.
    If bVVF Then
        IcSpmMax = CLng(0.8 * NcToneRX)
        Beta = 1.1
    End If
    NcSpmSuff = CLng(0.75 * NcToneRX) ' SSC: N di soglia per il numero di campioni con spettro > Beta * valor medio.
    NcSpmComp = NcToneRX - NcSpmSuff
'
    ReDim Char$(1 To MaxCar)          ' Vettore dei caratteri trovati
    ReDim PosChar&(1 To MaxCar)       ' e loro relative posizioni.
'
    ' Filtri:
    FiltFMin = 0.8 * TnFMin / FsRX  ' Frequenze di taglio min.
    FiltFMax = 1.2 * TnFMax / FsRX  ' e Max. del filtro passa banda [f/fs].
'
    ' Calcolo il filtro FIR:
    SintesiFIR_WM "Band Pass", NFilt, FiltFMin, FiltFMax, "Lanczos", 0.6
    ' Calcolo il filtro IIR:
    SintesiIIR_BT "Low Pass -> Band Pass", "Chebyshev", 0.2, 0.25, -20#, 1#, _
                  FiltFMin, FiltFMax
'
    ' Copia locale dei parametri del filtro IIR:
    LeggiCoefficienti_IIR NK, NCel, w(), Ac(), Bc()
'
    ' Parametri della trasmissione:
    NcGapTX = CLng(MinGap * FsTX)
    NcToneTX = CLng(ToneWidth * FsTX)
'
    ' Informazioni su frmConsole:
    frmConsole.lblCodice.Caption = Codice$
    frmConsole.chkSostERX.Caption = SC$ & " -> 2C &RX"
    frmConsole.chkSostETX.Caption = "2C -> " & SC$ & " &TX"
'
    ' Inizializzazione dei grafici:
    ReDim SpmG(1 To NcRX)
    ReDim MMbG(1 To NcRX)
    frmGrafici.Apri
'
'
'
End Sub
Private Sub Main()
'
'   Routine di ingresso del programma decodifica toni.
'
    ' Verifico la disponibilita' di almeno una scheda audio:
    If (Not CercaSchedeAudio) Then
        MsgBox "Questo PC non ha schede audio.", _
               vbCritical, " modDecoToni: Main"
        Exit Sub
    End If
'
    ' Trovo i mixers audio disponibili nel sistema:
    If (Not CercaMixersSp) Or (Not CercaMixersWi) Then
        MsgBox "La ricerca dei mixers audio ha" & vbNewLine & _
               "trovato una condizione imprevista." & vbNewLine & vbNewLine & _
               "Per la selezione dei canali di ingresso" & vbNewLine & _
               "provare ad usare il ""Volume Control""" & vbNewLine & _
               "di Windows." & vbNewLine, _
               vbCritical, " modDecoToni: Main"
    End If
'
    FileINI$ = App.Path & "\DecoToni.ini"
    LeggiParametri
'
    ImpostaParametri
'
    frmDecoToni.Show   ' Inutile: i Forms sono gia' caricati da ImpostaParametri.
'
    If IsLoaded(frmOpzioni) Then Unload frmOpzioni
'
    ' "Splash Form" iniziale:
    frmCopyright.Apri frmDecoToni, vbModeless, 4
'
'
'
End Sub
Public Sub Acquisizione(ByVal uDeviceWiID As Long)
'
'   Routine per l' acquisizione e la visualizzazione/analisi
'   dei dati.
'   Lavora con NBuff buffers alternati i.e., quando un buffer e'
'   completo viene inviato alle routines di analisi/visualizzazione
'   e subito dopo rimesso in coda, mentre il successivo e' gia' in
'   fase di di acquisizione.
'   Ver: 10/04/09.
'
    Dim Ib&, NBytes&, t0&, TmsBuffErr&, TmsAcq&, TmsProc&, lRet&, M$
    Dim FormatWaveIn As WAVEFORMATEX
'
    On Error GoTo Acquisizione_ERR
'
    NBuff = 4
    NBytes = 2 * NcRX * NCanali
    TmsAcq = 1000 * NcRX / FsRX   ' [ms].
    frmConsole.lblTempoAcq = Format$(TmsAcq, "#0.0")
'
    IcP = 0
    IcV = 0
    Ic = 0
    'IcO = 2147483647    ' Elimina lo spazio iniziale.
    IcO = -999999       ' Mette sempre uno spazio iniziale.
'
    ' Preparo/ripulisco i registri
    ' delle sezioni del filtro IIR:
    ReDim w(0 To NK, 1 To NCel)
'
    bRicercaPausa = True
    bRicercaTrigger = False
    frmConsole.lblStato = IIf(DecM = DecSSC, "--", "Attesa pausa")
    frmConsole.lblTrigLiv = Format$(TrigLivMax, "#0")
    frmConsole.cmdCancellaSeq_Click
    DoEvents
'
    TmsBuffErr = MAX0(10 * NBuff * TmsAcq, 500) ' massimo tempo di attesa per
                                                ' il riempimento dei buffers [ms].
'
'-- Preparazione al waveInStart: -------------------------------------------------------
'
    ' Operazione di sicurezza, nel caso il programma sia
    ' stato precedentemente terminato in modo non corretto:
    phwi = CLng(GetIniString(FileINI$, "Parametri:", "phwi", "0"))
    lRet = waveInClose(phwi)
'
    ' Imposto, inizialmente, lo stato
    ' della scheda audio:
    With FormatWaveIn
        .wFormatTag = WAVE_FORMAT_PCM
        .nChannels = NCanali
        .nSamplesPerSec = CLng(FsRX) ' [Hz]
        .wBitsPerSample = BitsPerSample
        .nBlockAlign = (.nChannels * .wBitsPerSample) \ 8
        .nAvgBytesPerSec = .nBlockAlign * .nSamplesPerSec
        .cbSize = 0
    End With
'
    ' Apro il collegamento con la scheda audio ...:
    lRet = waveInOpen(phwi, uDeviceWiID, VarPtr(FormatWaveIn), 0, 0, 0)
    ' ... e ne salvo l' handler per un eventuale tentativo
    ' di recupero in caso di forzata chiusura senza [Stop]:
    SaveIniString FileINI$, "Parametri:", "phwi", phwi
'
    If (lRet <> MMSYSERR_NOERROR) Or (phwi = 0) Then
        M$ = "Il collegamento con la scheda audio non e' disponibile." & vbNewLine & vbNewLine
        M$ = M$ & "Si consiglia di chiudere tutti i programmi che potrebbero" & vbNewLine
        M$ = M$ & "usare la scheda audio o di riavviare il PC." & vbNewLine & vbNewLine
        M$ = M$ & "waveInOpen - Err: " & WaveERR(lRet)
        MsgBox M$, vbCritical, " modDecoToni: Acquisizione"
        lRet = waveInClose(phwi)
        Exit Sub
    End If
'
    ReDim WaveInHdr(1 To NBuff) As WAVEHDR
    ReDim InData(1 To NcRX, 1 To NBuff) As Integer
    ReDim InDataC(1 To NcRX) As Integer
    For Ib = 1 To NBuff
        WaveInHdr(Ib).lpData = VarPtr(InData(1, Ib))
        WaveInHdr(Ib).dwBufferLength = NBytes ' [Bytes].
        WaveInHdr(Ib).dwUser = Ib
        WaveInHdr(Ib).dwFlags = 0
        WaveInHdr(Ib).dwLoops = 0
'
        lRet = waveInPrepareHeader(phwi, VarPtr(WaveInHdr(Ib)), Len(WaveInHdr(Ib)))
        If (lRet <> MMSYSERR_NOERROR) Then _
            Err.Raise 1001, , "waveInPrepareHeader #" & Ib & " - Err: " & WaveERR(lRet)
    Next Ib
    LenInHeaders = Len(WaveInHdr(1))
'
    ' Inizio l' acquisizione con il buffer #1 e metto
    ' in coda l' acquisizione con gli altri buffers:
    For Ib = 1 To NBuff
        lRet = waveInAddBuffer(phwi, VarPtr(WaveInHdr(Ib)), LenInHeaders)
        If (lRet <> MMSYSERR_NOERROR) Then
            Err.Raise 1001, , "waveInAddBuffer #" & Ib & " - Err: " & WaveERR(lRet)
        End If
    Next Ib
    Ib = 1
'
'-- Acquisizione: ----------------------------------------------------------------------
'
    lRet = waveInStart(phwi)    ' Inizio il collegamento con la scheda audio.
    If (lRet <> MMSYSERR_NOERROR) Then
        Err.Raise 1001, , "waveInStart - Err: " & WaveERR(lRet)
    End If
    bAcqOn = True               ' L' acquisizione e' in corso.
'
    Do
        frmConsole.lblIb.Caption = Ib
'
        t0 = GetTickCount   ' [ms].
        Do  ' Attendo il riempimento del buffer Ib.
            If (TmsBuffErr < (GetTickCount - t0)) Then
                Err.Raise 1001, , "Il sistema non risponde."
            End If
        Loop Until ((WaveInHdr(Ib).dwFlags And WHDR_DONE) = WHDR_DONE)
        'frmConsole.lblStato.Caption = GetTickCount - t0 ' Per prove.
'
        ' Solo per informazione/Debug:
        t0 = GetTickCount
'
        ' Copio il buffer Ib nel vettore InDataC() da passare all' analisi:
        CopyMemory InDataC(1), InData(1, Ib), NBytes
'
        ' Rimetto in coda per l' acquisizione il buffer Ib:
        lRet = waveInAddBuffer(phwi, VarPtr(WaveInHdr(Ib)), LenInHeaders)
'
        ' Mando alla decodifica i dati copia del buffer Ib:
        If (DecM = DecDFT) Then
            ' Decodifica con DFT (OK):
            Analisi_DFT InDataC()
'
        ElseIf (DecM = DecSPM) Then
            ' Decodifica con spettro mobile (OK):
            Analisi_SPM InDataC()
'
        ElseIf (DecM = DecSSC) Then
            ' Decodifica con spettro mobile
            ' su segnale completo (OK):
            Decodifica_SSC InDataC()
        End If
'
        ' Solo per informazione/Debug:
        If bAcqOn Then
            TmsProc = GetTickCount - t0   ' [ms].
            frmConsole.lblTempoProc = Format$(TmsProc, "#0.0")
            If (TmsAcq < TmsProc) Then
                frmConsole.lblTempoProc.BackColor = vbRed
            Else
                frmConsole.lblTempoProc.BackColor = vbButtonFace
            End If
        End If
'
        ' Calcolo l' indice del buffer successivo:
        Ib = Ib + 1
        If (NBuff < Ib) Then Ib = 1
'
        DoEvents
    Loop While bAcqOn
'
'
Acquisizione_ERR:
    If (Err.Number <> 0) Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modDecoToni: Acquisizione"
    End If
'
    lRet = waveInReset(phwi)
'
    ' Libero i buffers di acquisizione dei dati:
    For Ib = 1 To NBuff
        lRet = waveInUnprepareHeader(phwi, VarPtr(WaveInHdr(Ib)), LenInHeaders)
    Next Ib
'
    ' Chiudo il collegamento con la scheda audio:
    lRet = waveInClose(phwi)
'
'
'
End Sub
Private Sub Decodifica_SSC(InData() As Integer)
'
'   Routine per la decodifica del segnale in ingresso.
'   Questa routine e' chiamata da Acquisisizione ogni
'   volta che e' pronto un nuovo vettore InData().
'   Routine con decodifica di tutti i dati in ingresso,
'   i.e. senza attesa della pausa e con spettro mobile.
'
'   Ver: 25/03/05.
'
    Dim I&, NChar&, K&, J&, L&, Y!
    Static IcKn&, K_O&
'
    On Error Resume Next    ' Gestisce l' overflow occasionale di Char$() e PosChar&().
'
    NChar = 0
    For I = 1 To NcRX   ' I e' la coord. temporale (N di campione) all' interno
                        ' del blocco InData() di dati acquisiti.
        IcI = IcI + 1   ' IcI e' la coord. temporale (N di campione)
                        ' dalla fine dell' ultima stringa ricevuta.
'
        If bFiltroON Then
            ' Filtro FIR i dati in ingresso:
            'VIn2(I) = FIR(CSng(InData(I)))
'
            ' Filtro IIR i dati in ingresso.
            ' VIn2(I) = IIR(CSng(InData(I))) sviluppato
            ' in linea per velocizzare il calcolo:
            Y = InData(I)
            For J = 1 To NCel
                w(0, J) = Y
                Y = 0!
                For L = NK To 1 Step -1
                    w(0, J) = w(0, J) - Bc(L, J) * w(L, J)
                    Y = Y + Ac(L, J) * w(L, J)
                    w(L, J) = w(L - 1, J)
                Next L
                Y = Y + Ac(0, J) * w(0, J)
            Next J
'
            VIn2(I) = Y
'
        Else
            ' Non filtro i dati in ingresso:
            VIn2(I) = CSng(InData(I))
        End If
'
        ' Calcolo gli spettri mobili alle
        ' frequenze della tabella dei toni:
        SPM_MF_R IcI, VIn2(I), SpmMF(), MMbSg
'
        For K = 0 To NTonesDec - 1
            ' Il valore dello spettro alla
            ' frequenza ToneFreq(K) e' mag-
            ' giore del valor medio corrente?
            If (Beta * MMbSg < SpmMF(K)) And (1 < MMbSg) _
            And ((IcKn < IcI) Or (K <> K_O)) _
            And (bSSC_NS Or (SogliaSigRMS <= MMbSg)) Then
                ' Si, incremento il numero di
                ' campioni sopra la media:
                NcSpmCont(K) = NcSpmCont(K) + 1
            Else
                ' No, il valore dello spettro
                ' e' sceso sotto il valor medio
                ' e quindi azzero la somma:
                NcSpmCont(K) = 0
            End If
'
            If (NcSpmSuff < NcSpmCont(K)) Then
                ' Il numero di campioni con spettro
                ' superiore alla media, per il tono
                ' K, ha superato il valore stabilito:
                NcSpmCont(K) = 0
                IcIf = IcI  ' Puntatore al campione finale del tono K riconosciuto.
'
                ' La ricerca di un altro tono K iniziera'
                ' solo dopo il campione IcKn:
                IcKn = IcI + NcSpmComp
                K_O = K
'
                ' Aggiungo alla stringa ricevuta
                ' il codice del tono trovato:
                StringaRX$ = StringaRX$ & ToneChar$(K)
'
                ' Memorizzo, per il grafico, il
                ' carattere trovato (opzionale):
                NChar = NChar + 1
                Char$(NChar) = ToneChar$(K)
                PosChar(NChar) = I - NcSpmSuff + NcToneRX_2
            End If
        Next K
'
        ' Se sono trascorsi piu' di NcSeqSep campioni
        ' dall' ultimo tono decodificato, allora
        ' elaboro la stringa finora formata:
        If (NcSeqSep < (IcI - IcIf)) And (0 < Len(StringaRX$)) Then
            ' Ignoro le sequenze con un numero di caratteri inferiore
            ' a MinCar e tratto, invece, quelle piu' lunghe:
            If (MinCar <= Len(StringaRX$)) Then TrattaStringaRX
            StringaRX$ = ""
'
            ' Riazzero il contatore dei campioni IcI (questo
            ' fa' anche ripartire il calcolo del valor medio
            ' in SPM_MF_R) ed il ritardo IcKn sulla decodifica
            ' dei caratteri doppi:
            IcI = 0
            IcKn = 0
        End If
'
        ' Preparo i vettori per
        ' il grafico (opzionale):
        SpmG(I) = SpmMF(ICarSpettro)
        MMbG(I) = MMbSg
    Next I
'
    If bDisegnaGrafici Then
        ' Disegno il grafico di segnale
        ' e spettro mobile (opzionale):
        frmGrafici.DisegnaSegnale_SSC NcVin2, VIn2(), NChar, PosChar(), Char$()
        frmGrafici.DisegnaSpettroMobile NcVin2, SpmG(), MMbG()
    End If
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Private Sub Decodifica_SPM()
'
'   Analizza le frequenze del segnale contenuto in Vin()
'   e scrive i codici dei toni trovati.
'   Prove per l' uso dello spettro mobile quale strumento
'   di decodifica:
'   Ver: 14/04/04
'
    'Exit Sub
'
    Dim I&, NChar&, K&, ToneCod$
    ' Azzeramento dei vettori:
    ReDim Char$(1 To MaxCar)          ' Vettore dei caratteri trovati
    ReDim PosChar&(1 To MaxCar)       ' e loro relativr posizioni.
    ReDim IcSpm(0 To NTonesDec - 1)
    ReDim vSPM(1 To NcVin)
    ReDim vMMb(1 To NcVin)
'
    On Error Resume Next    ' Gestisce l' overflow occasionale di Char$() e PosChar&().
'
    NChar = 0
    For I = 1 To IcV
        ' Calcolo gli spettri mobili alle
        ' frequenze della tabella dei toni:
        SPM_MF_R I, VIn(I), SpmMF(), MMbSg
'
        For K = 0 To NTonesDec - 1
            ' Il valore dello spettro alla
            ' frequenza ToneFreq(K) e' mag-
            ' giore del valor medio corrente?
            If (Beta * MMbSg < SpmMF(K)) Then
                ' Si, incremento il numero di
                ' campioni sopra la media:
                IcSpm(K) = IcSpm(K) + 1
                'vSPM(I) = SpmMF(K) ' Per vedere gli spettri mobili di tutti i caratteri.
            Else
                ' No, il valore dello spettro
                ' e' sceso sotto il valor medio
                ' e quindi azzero la somma:
                IcSpm(K) = 0
            End If
'
            If (IcSpmMax < IcSpm(K)) Then
                ' Il numero di campioni con spettro
                ' superiore alla media ha superato
                ' il valore stabilito:
                IcSpm(K) = 0
'
                ' Cerco il codice del tono trovato:
                ToneCod$ = ToneChar$(K)
'
                ' e lo aggiungo alla stringa ricevuta:
                If (NcSeqSep < (IcIs + I - IcO)) Then
                    StringaRX$ = StringaRX$ & " " & ToneCod$
                Else
                    StringaRX$ = StringaRX$ & ToneCod$
                End If
                IcO = IcIs + I
'
                ' Memorizzo, per il grafico, il
                ' carattere trovato (opzionale):
                NChar = NChar + 1
                Char$(NChar) = ToneCod$
                PosChar(NChar) = I - NcToneRX / 2
            End If
        Next K
'
        ' Peparo i vettori per
        ' il grafico (opzionale):
        vSPM(I) = SpmMF(ICarSpettro) ' Per vedere lo spettro mobile del solo carattere ICarSpettro.
        vMMb(I) = MMbSg
    Next I
'
    ' Ignoro le sequenze con un numero di caratteri inferiore a MinCar
    ' e visualizzo, invece, quelle piu' lunghe:
    If (MinCar <= Len(Replace(StringaRX$, " ", ""))) Then TrattaStringaRX
    StringaRX$ = ""
'
    If bDisegnaGrafici Then
        ' Disegno il grafico di segnale
        ' e spettro mobile (opzionale):
        frmGrafici.DisegnaSegnale_SPM IcV, VIn(), NChar, PosChar(), Char$(), IcV1
        frmGrafici.DisegnaSpettroMobile IcV, vSPM(), vMMb()
    End If
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Private Sub Decodifica_DFT()
'
'   Analizza le frequenze del segnale contenuto in Vin()
'   e scrive i codici dei toni trovati.
'   Questa routine esegue la trasformata solo in corrispondenza
'   delle frequenze previste dal codice tonale selezionato (DFT).
'   Ver: 24/03/04.
'   Agg: 13/04/04 (Windowing e calcolo sull' effettiva lunghezza del segnale).
'
    Dim I&, I1&, J&, ToneCod$
    Dim SMed#, SSig#, bSpettro As Boolean
    ' Azzeramento dei vettori:
    ReDim Sp#(0 To NTonesDec - 1)
    ReDim Char$(1 To MaxCar)          ' Vettore dei caratteri trovati
'
    On Error Resume Next    ' Gestisce l' overflow occasionale di Char$().
'
    I1 = 0
    For I = NcOff To MIN0(IcV, NcSeqRX) Step NcToneRX
        ' Preparo i vettori dei dati per la DFT
        ' con la parte selezionata del segnale.
        ' Questa selezione e' centrata intorno al
        ' punto medio (stimato) di ogni tono della
        ' sequenza e l' uso della Window compensa
        ' i piccoli scostamenti del segnale reale:
        For J = 0 To NcFT - 1
            D(J) = CDbl(VIn(I + J)) * WinP(J)
        Next J
'
        ' Eseguo l' analisi in frequenza
        ' della parte selezionata del segnale:
        DFT_1 D(), Rea(), Imm(), SSp(), Imm(), SMax, ISMax, SMed
'
        I1 = I1 + 1
        If (SogliaSigRMS < SMax) And (SMed * ALFA < SMax) Then
            ' Cerco il codice del tono trovato:
            ToneCod$ = ToneChar$(ISMax)
'
            ' e lo aggiungo alla stringa ricevuta:
            If (NcSeqSep < (IcIs + I - IcO)) Then
                StringaRX$ = StringaRX$ & " " & ToneCod$
            Else
                StringaRX$ = StringaRX$ & ToneCod$
            End If
            IcO = IcIs + I
'
            ' Peparo i vettori per
            ' il grafico (opzionale):
            Char$(I1) = ToneCod$
            If (ToneCod$ = CarSpettro$) Then
                Sp() = SSp()
                bSpettro = True
            End If
        End If
    Next I
'
    ' Ignoro le sequenze con un numero di caratteri inferiore a MinCar
    ' e visualizzo, invece, quelle piu' lunghe:
    If (MinCar <= Len(Replace(StringaRX$, " ", ""))) Then TrattaStringaRX
    StringaRX$ = ""
'
    If bDisegnaGrafici Then
        ' Disegno il grafico di segnale
        ' e spettri (opzionale):
        frmGrafici.DisegnaSegnale_DFT IcV, VIn(), Char$(), IcV1
        If bSpettro Then
            frmGrafici.DisegnaSpettro_DFT NTonesDec, ToneFreq(), Sp()
            bSpettro = False
        End If
    End If
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Private Sub Analisi_SPM(InData() As Integer)
'
'   Routine per la preparazione del vettore VIn() da decodificare.
'   Questa routine e' chiamata da Acquisisizione ogni volta che e'
'   pronto un nuovo vettore InData().
'   Routine con filtrazione dei dati in ingresso
'   e decodifica con spettro mobile.
'   Ver: 24/03/04.
'   Agg: 12/04/04
'
    Dim I&, IdFil!
'
    For I = 1 To NcRX
        Ic = Ic + 1
'
        If bFiltroON Then
            ' Filtro FIR i dati in ingresso:
            'IdFil = FIR(CSng(InData(I)))
'
            ' Filtro IIR i dati in ingresso:
            IdFil = IIR(CSng(InData(I)))
'
        Else
            ' Non filtro i dati in ingresso:
            IdFil = (CSng(InData(I)))
        End If
'
        If bRicercaPausa Then
            ' Attendo una pausa (Min gap between seq.):
            If (Abs(IdFil) < TrigLivMin) Then
                IcP = IcP + 1
            Else
                IcP = 0
            End If
            If (NcZeri < IcP) Then
                ' Pausa trovata...
                IcP = 0
                bRicercaPausa = False
                bRicercaTrigger = True
                frmConsole.lblStato = "Attesa segnale"
            End If
'
        ElseIf bRicercaTrigger Then
            ' Ho trovato la pausa ed ora attendo
            ' l' inizio di una sequenza:
            If (TrigLivMax < Abs(IdFil)) Then
                ' Inizio trovato...
                IcV = 0
                IcIs = Ic               ' Marco l' istante di inizio della sequenza.
                ReDim VIn(1 To NcVin)   ' Svuoto il vettore di accumulo.
                bRicercaTrigger = False
                frmConsole.lblStato = "Acquisizione"
            End If
'
        Else
            ' Ho trovato l' inizio della
            ' sequenza e quindi riempio
            ' il vettore VIn():
            IcV = IcV + 1
            VIn(IcV) = IdFil
            If (IcV = NcVin) Then
                ' VIn() e' completo e
                ' lo decodifico:
                Decodifica_SPM
'
                ' Attendo la prossima pausa:
                bRicercaPausa = True
                frmConsole.lblStato = "Attesa pausa"
            End If
'
            ' Verifico che la durata del segnale non sia
            ' inferiore ad, almeno, la lunghezza di un tono:
            If (Abs(IdFil) < TrigLivMin) Then
                IcSc = IcSc + 1
            Else
                IcSc = 0
            End If
            If (NcP2 < IcSc) And ((Ic - IcIs) < NcToneRX) Then
                IcSc = 0
                bRicercaTrigger = True
                frmConsole.lblStato = "Attesa segnale c."
            End If
'
            ' Verifico che non ci siano
            ' pause intermedie:
            If (Abs(IdFil) < TrigLivMin) Then
                IcP = IcP + 1
            Else
                IcP = 0
            End If
            If (NcZeri < IcP) Then
                ' Pausa trovata...
                IcP = 0
                ' Decodifico la parte di
                ' segnale ricevuta:
                Decodifica_SPM
'
                ' Ritorno in attesa
                ' dell' inizio del segnale:
                bRicercaTrigger = True
                frmConsole.lblStato = "Attesa segnale c."
            End If
        End If
    Next I
'
    ' Memorizzo la fine del buffer:
    IcV1 = IcV
'
'
'
End Sub
Private Sub Analisi_DFT(InData() As Integer)
'
'   Routine per la preparazione del vettore VIn() da decodificare.
'   Questa routine e' chiamata da Acquisisizione ogni volta che e'
'   pronto un nuovo vettore InData().
'   Routine con filtrazione dei dati in ingresso
'   e decodifica con DFT.
'   Ver: 24/03/04.
'   Agg: 12/04/04
'
    Dim I&, IdFil!
'
    For I = 1 To NcRX
        Ic = Ic + 1
'
        If bFiltroON Then
            ' Filtro FIR i dati in ingresso:
            'IdFil = FIR(CSng(InData(I)))
'
            ' Filtro IIR i dati in ingresso:
            IdFil = IIR(CSng(InData(I)))
'
        Else
            ' Non filtro i dati in ingresso:
            IdFil = (CSng(InData(I)))
        End If
'
        If bRicercaPausa Then
            ' Attendo una pausa (Min gap between seq.):
            If (Abs(IdFil) < TrigLivMin) Then
                IcP = IcP + 1
            Else
                IcP = 0
            End If
            If (NcZeri < IcP) Then
                ' Pausa trovata...
                IcP = 0
                bRicercaPausa = False
                bRicercaTrigger = True
                frmConsole.lblStato = "Attesa segnale"
            End If
'
        ElseIf bRicercaTrigger Then
            ' Ho trovato la pausa ed ora attendo
            ' l' inizio di una sequenza:
            If (TrigLivMax < Abs(IdFil)) Then
                ' Inizio trovato...
                IcV = 0
                IcIs = Ic               ' Marco l' istante di inizio della sequenza.
                ReDim VIn(1 To NcVin)   ' Svuoto il vettore di accumulo.
                bRicercaTrigger = False
                frmConsole.lblStato = "Acquisizione"
            End If
'
        Else
            ' Ho trovato l' inizio della
            ' sequenza e quindi riempio
            ' il vettore VIn():
            IcV = IcV + 1
            VIn(IcV) = IdFil
            If (IcV = NcVin) Then
                ' VIn() e' completo e
                ' lo decodifico:
                Decodifica_DFT
'
                ' Attendo la prossima pausa:
                bRicercaPausa = True
                frmConsole.lblStato = "Attesa pausa"
            End If
'
            ' Verifico che la durata del segnale non sia
            ' inferiore ad, almeno, la lunghezza di un tono:
            If (Abs(IdFil) < TrigLivMin) Then
                IcSc = IcSc + 1
            Else
                IcSc = 0
            End If
            If (NcP2 < IcSc) And (Ic - IcIs < NcToneRX) Then
                IcSc = 0
                bRicercaTrigger = True
                frmConsole.lblStato = "Attesa segnale c."
            End If
'
            ' Verifico che non ci siano
            ' pause intermedie:
            If (Abs(IdFil) < TrigLivMin) Then
                IcP = IcP + 1
            Else
                IcP = 0
            End If
            If (NcZeri < IcP) Then
                ' Pausa trovata...
                IcP = 0
                ' Decodifico la parte di
                ' segnale ricevuta:
                Decodifica_DFT
'
                ' Ritorno in attesa
                ' dell' inizio del segnale:
                bRicercaTrigger = True
                frmConsole.lblStato = "Attesa segnale c."
            End If
        End If
    Next I
'
    ' Memorizzo la fine del buffer:
    IcV1 = IcV
'
'
'
End Sub
Public Sub SuonaSequenza()
'
'   Rev. 07/03/2004 (2 versione).
'   Rev. 20/04/2009 (3 versione).
'   Rev. 02/12/2009 (4 versione).
'
    Dim lRet&
'
    On Error GoTo SuonaSequenza_ERR
'
    ' Suono il buffer OutData():
    lRet = waveOutWrite(phwo, WaveOutHdr, LenOutHeader)
    If (lRet <> MMSYSERR_NOERROR) Then
        Err.Raise 1001, , "waveOutWrite - Err: " & WaveERR(lRet)
    End If
'
'
SuonaSequenza_ERR:
    If (Err.Number <> 0) Then
        MsgBox Err.Number & vbNewLine & Err.Description, _
               vbCritical, " modDecoToni: SuonaSequenza"
        Err.Clear
    End If
'
'
'
End Sub
Public Sub SalvaParametri()
'
'   Salva, su file .INI, i parametri correntemente usati:
'
    ' Form frmOpzioni:
    SaveIniString FileINI$, "Parametri:", "MixerSpI", MixerSpI
    SaveIniString FileINI$, "Parametri:", "MixerWiI", MixerWiI
'
    SaveIniString FileINI$, "Parametri:", "Codice", Codice$
    SaveIniString FileINI$, "Parametri:", "FileSeqTxt", FileSeqTxt$
    SaveIniString FileINI$, "Parametri:", "FsRX", FsRX
    SaveIniString FileINI$, "Parametri:", "FsTX", FsTX
    SaveIniString FileINI$, "Parametri:", "Amp16", Amp16
'
    ' Form frmConsole:
    SaveIniString FileINI$, "Parametri:", "bAutoScroll", bAutoScroll
'
    SaveIniString FileINI$, "Parametri:", "Alfa", ALFA
    SaveIniString FileINI$, "Parametri:", "SogliaSigRMS", SogliaSigRMS
    SaveIniString FileINI$, "Parametri:", "MinCar", MinCar
    SaveIniString FileINI$, "Parametri:", "NcSeqSep", NcSeqSep
'
    SaveIniString FileINI$, "Parametri:", "DecM", DecM
    SaveIniString FileINI$, "Parametri:", "SSC Soglia OFF", bSSC_NS
'
    SaveIniString FileINI$, "Parametri:", "Filtro ON", bFiltroON
    SaveIniString FileINI$, "Parametri:", "bSostSCRX", bSostSCRX
    SaveIniString FileINI$, "Parametri:", "bSostSCTX", bSostSCTX
'
    ' Form frmGrafici:
    SaveIniString FileINI$, "Parametri:", "Grafico ViMax", ViMax
'
'
'
End Sub
Private Sub LeggiParametri()
'
'   Legge (ed eventualmente corregge), dal file .INI, i parametri preferenziali:
'
    On Error Resume Next
'
    ' Form frmOpzioni:
    MixerSpI = CLng(GetIniString(FileINI$, "Parametri:", "MixerSpI", "1"))
    MixerSpI = MAX0(MIN0(MixerSpI, NMixSp), 1)
    MixerWiI = CLng(GetIniString(FileINI$, "Parametri:", "MixerWiI", "1"))
    MixerWiI = MAX0(MIN0(MixerWiI, NMixWi), 1)
'
    Codice$ = GetIniString(FileINI$, "Parametri:", "Codice", "EEA")
    FileSeqTxt$ = GetIniString(FileINI$, "Parametri:", "FileSeqTxt", "Testi 5 Toni.txt")
    FsRX = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "FsRX", 11025#)))
    FsRX = DMAX1(FsRX, 8000)
    FsTX = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "FsTX", 11025#)))
    FsTX = DMAX1(FsTX, 8000)
    Amp16 = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "Amp16", 3000#)))
    Amp16 = DMAX1(Amp16, 1000)
'
    ' Form frmConsole:
    bAutoScroll = CBool(GetIniString(FileINI$, "Parametri:", "bAutoScroll", True))
'
    ALFA = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "Alfa", 15#)))
    ALFA = DMAX1(ALFA, 1)
    SogliaSigRMS = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "SogliaSigRMS", 500#)))
    MinCar = CLng(GetIniString(FileINI$, "Parametri:", "MinCar", 3&))
    MinCar = MAX0(MinCar, 1)
    NcSeqSep = CLng(GetIniString(FileINI$, "Parametri:", "NcSeqSep", CLng(0.15 * FsRX)))
    NcSeqSep = MAX0(NcSeqSep, CLng(0.15 * FsRX))
'
    DecM = CLng(GetIniString(FileINI$, "Parametri:", "DecM", DecDFT))
    DecM = MAX0(MIN0(DecM, DecSSC), DecDFT)
    bSSC_NS = CBool(GetIniString(FileINI$, "Parametri:", "SSC Soglia OFF", True))
'
    bFiltroON = CBool(GetIniString(FileINI$, "Parametri:", "Filtro ON", True))
    bSostSCRX = CBool(GetIniString(FileINI$, "Parametri:", "bSostSCRX", False))
    bSostSCTX = CBool(GetIniString(FileINI$, "Parametri:", "bSostSCTX", False))
'
    ' Form frmGrafici:
    ViMax = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "Grafico ViMax", 10000!)))
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Private Sub TrattaStringaRX()
'
'   Elabora la stringa ricevuta StringaRX$
'   e la scrive nella tabella:
'   Ver: 11/04/04, 19/04/04.
'   Agg: 21/12/09.
'
    Dim I&, Istr&, VvfRX$
'
    If bVVF Then
        ' Elimino i caratteri doppi
        ' del codice VVF a 100 [ms]:
        If (NTonesInSeq < Len(Replace(StringaRX$, " ", ""))) Then
            For I = 1 To Len(StringaRX$)
                VvfRX$ = VvfRX$ & Mid$(StringaRX$, I, 1)
                If (Mid$(StringaRX$, I, 1) = Mid$(StringaRX$, I + 1, 1)) Then
                    I = I + 1
                End If
            Next I
            StringaRX$ = VvfRX$
        End If
    End If
'
    If bSostSCRX Then
        ' Sostituisco le SC$ con doppi caratteri:
        For I = 2 To Len(StringaRX$)
            If (Mid$(StringaRX$, I, 1) = SC$) Then
                StringaRX$ = Left$(StringaRX$, I - 1) & Mid$(StringaRX$, I - 1, 1) _
                           & Mid$(StringaRX$, I + 1)
            End If
        Next I
    End If
'
    ' Visualizzo la stringa ricevuta:
    If (DecM = DecSSC) Then
        frmConsole.ScriviStringaRX_SSC StringaRX$
'
    Else ' If (DecM = DecDFT) Or (DecM = DecSPM) Then
        frmConsole.ScriviStringaRX_DFT_SPM StringaRX$
    End If
'
'
'
End Sub
Public Sub IniziaSuonoSequenza(ByVal uDeviceSpID As Long, ByVal StringaTX$)
'
'   Rev. 07/03/2004 (2 versione).
'   Rev. 20/04/2009 (3 versione).
'   Rev. 02/12/2009 (4 versione).
'
    Dim NcToneTX_L As Long  ' N di campioni usato localmente per i toni.
    Dim NcTX As Long        ' N di campioni nella sequenza da trasmettere.
'
    Dim I&, Ci&, K&, Omega#, PhiI#, ox#, lRet&
    Dim FormatWaveOut As WAVEFORMATEX   ' Sound format.
'
    On Error GoTo IniziaSuonoSequenza_ERR
'
    ' NcToneTX: N di campioni in un tono della sequenza da trasmettere.
    If (frmConsole.chkDoppioLungToni.Value = vbChecked) Then
        NcToneTX_L = 2 * NcToneTX
    Else
        NcToneTX_L = NcToneTX
    End If
'
    ' Calcolo il numero di campioni da emettere ...:
    NcTX = NcGapTX + Len(StringaTX$) * NcToneTX_L
    ' ... ed imposto di conseguenza il vettore da "suonare":
    ReDim OutData(1 To NcTX * NCanali) As Integer
'
    TmsSeqTX = 1000 * NcTX / FsTX   ' Durata della sequenza da trasmettere [ms].
'
'-- Preparazione del vettore OutData() con i campioni da emettere: ---------------------
'
    If bSostSCTX Then
        ' Sostituisco i doppi caratteri con SC$:
        For I = 2 To Len(StringaTX$)
            If (Mid$(StringaTX$, I, 1) = Mid$(StringaTX$, I - 1, 1)) Then
                StringaTX$ = Left$(StringaTX$, I - 1) & SC$ & Mid$(StringaTX$, I + 1)
            End If
        Next I
    End If
'
    ' Inizio la sequenza con NcGapTX
    ' campioni impostati a 0:
    K = NcGapTX
    Omega = 0#
    PhiI = 0#
'
    Ci = 1
    For I = 1 To NcTX
        If (K < I) Then
            ' Trovo il carattere da emettere e ne
            ' imposto la frequenza corrispondente:
            PhiI = Omega * CDbl(I) + PhiI
            Omega = PI2 * CodeToFreq(Mid$(StringaTX$, Ci, 1)) / FsTX
            Ci = Ci + 1
'
            ' Compenso la fase per avere
            ' la continuita' del segnale:
            PhiI = PhiI - Omega * CDbl(I)
'
            ' Questa frequenza verra' mantenuta
            ' per i successivi NcToneTX_L campioni:
            K = I + NcToneTX_L
        End If
'
        ox = Amp16 * Sin(Omega * CDbl(I) + PhiI)
        OutData(I) = CInt(ox)
    Next I
'
'-- Preparazione al waveOutWrite: ------------------------------------------------------
'
    ' Operazione di sicurezza, nel caso il programma sia
    ' stato precedentemente terminato in modo non corretto:
    phwo = CLng(GetIniString(FileINI$, "Parametri:", "phwo", "0"))
    lRet = waveOutClose(phwo)
'
    ' Imposto, inizialmente, lo stato
    ' della scheda audio:
    With FormatWaveOut
        .wFormatTag = WAVE_FORMAT_PCM           ' uncompressed sound format.
        .nChannels = NCanali                    ' 1 = mono; 2 = stereo.
        .wBitsPerSample = BitsPerSample         ' bits per sample per channel.
        .nSamplesPerSec = CLng(FsTX)            ' samples per second.
        .nBlockAlign = .nChannels * .wBitsPerSample / 8
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
        .cbSize = 0
    End With
'
    ' Apro il collegamento con la scheda audio ...:
    lRet = waveOutOpen(phwo, uDeviceSpID, VarPtr(FormatWaveOut), 0, 0, 0)
    If (lRet <> MMSYSERR_NOERROR) Or (phwo = 0) Then
        Err.Raise 1001, , "waveOutOpen - Err: " & WaveERR(lRet)
    End If
    ' ... e ne salvo l' handler per un eventuale tentativo di recupero
    ' in caso di forzata chiusura senza TerminaSuonoSequenza:
    SaveIniString FileINI$, "Parametri:", "phwo", phwo
'
    ' Preparo il buffer per l' emissione dei dati:
    WaveOutHdr.lpData = VarPtr(OutData(1))
    WaveOutHdr.dwBufferLength = Len(OutData(1)) * NcTX
    WaveOutHdr.dwFlags = 0&
    WaveOutHdr.dwLoops = 0&
    WaveOutHdr.dwBytesRecorded = 0&
    WaveOutHdr.dwUser = 1&
    WaveOutHdr.lpNext = 0&
    LenOutHeader = Len(WaveOutHdr)
'
    lRet = waveOutPrepareHeader(phwo, WaveOutHdr, LenOutHeader)
    If (lRet <> MMSYSERR_NOERROR) Then
        Err.Raise 1001, , "waveOutPrepareHeader - Err: " & WaveERR(lRet)
    End If
'
'
IniziaSuonoSequenza_ERR:
    If (Err.Number <> 0) Then
        MsgBox Err.Number & vbNewLine & Err.Description, _
               vbCritical, " modDecoToni: IniziaSuonoSequenza"
        Err.Clear
    End If
'
'
'
End Sub
Public Sub TerminaSuonoSequenza()
'
'
    Dim t0&, lRet&
'
    ' Attendo, eventualmente, la fine
    ' della "suonata" in corso:
    t0 = GetTickCount   ' [ms].
    Do
        DoEvents
    Loop Until ((WaveOutHdr.dwFlags And WHDR_DONE) = WHDR_DONE) _
            Or (2 * TmsSeqTX < (GetTickCount - t0))
'
    lRet = waveOutReset(phwo)
'
    ' Libero il buffer di emissione dei dati ...:
    lRet = waveOutUnprepareHeader(phwo, WaveOutHdr, LenOutHeader)
    If (lRet <> MMSYSERR_NOERROR) Then
        MsgBox "waveOutUnPrepareHeader - Err: " & WaveERR(lRet), vbCritical, " modDecoToni: TerminaSuonoSequenza"
    End If
'
    ' ... e chiudo il collegamento con la scheda audio:
    lRet = waveOutClose(phwo)
    If (lRet <> MMSYSERR_NOERROR) Then
      MsgBox "waveOutClose - Err: " & WaveERR(lRet), vbCritical, " modDecoToni: TerminaSuonoSequenza"
    End If
'
'
'
End Sub
